package com.mobisoft.youtubedatareading;

import android.app.Dialog;
import android.content.Context;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.os.Bundle;
import android.view.animation.AnimationUtils;
import android.widget.ImageView;
import android.widget.TextView;

public class CustomProgressDialog extends Dialog {
	private Context context;
	private String heading;
	private String message;
	private TextView txtHeading;
	private TextView txtMsg;
	private ImageView imgLogo;

	public CustomProgressDialog(Context context, String heading, String message) {
		super(context);
		this.context = context;
		this.heading = heading;
		this.message = message;
	}

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.progress_dialog);
		getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
		initLayout();

	}

	private void initLayout() {
		txtHeading = (TextView) findViewById(R.id.txt_progress_heading);
		txtMsg = (TextView) findViewById(R.id.txt_loding_msg);
		imgLogo = (ImageView) findViewById(R.id.img_loading);

		txtHeading.setText(heading);
		txtMsg.setText(message);

	}

	@Override
	protected void onStart() {
		imgLogo.startAnimation(AnimationUtils.loadAnimation(context,
				R.anim.loading_rotation));

	}

	@Override
	protected void onStop() {
		super.onStop();
	}
}
