package com.mobisoft.youtubedatareading;

import java.util.ArrayList;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.Context;
import android.graphics.Typeface;
import android.os.Bundle;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;

import com.mobisoft.youtubedatareading.adapters.YouTubeBrowseAdapter;
import com.mobisoft.youtubedatareading.interfaces.AlertDialogDelegate;
import com.mobisoft.youtubedatareading.interfaces.KeyValuePairInterface;
import com.mobisoft.youtubedatareading.interfaces.YouTubeCategoriesURL;
import com.mobisoft.youtubedatareading.listeners.YouTubeCategoryItemClickListener;
import com.mobisoft.youtubedatareading.listeners.YouTubeSearchBtnListner;
import com.mobisoft.youtubedatareading.models.YoutubeBrowseModel;
import com.mobisoft.youtubedatareading.utils.UtilityClass;

public class YouTubeCategoryActivity extends Activity implements
		YouTubeCategoriesURL, AlertDialogDelegate, KeyValuePairInterface {
	private Context context;
	private TextView txtHeading;
	private EditText etSearch;
	private Button btnSearch;
	private TextView txtTitle;
	private ListView listYoutubeCategory;
	private YouTubeBrowseAdapter youTubeBrowseAdapter;
	private ArrayList<YoutubeBrowseModel> youtubeBrowseList;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.browse_you_tube);
		initLayout();
	}

	private void initLayout() {
		context = this;

		Typeface HelveticaNueu = UtilityClass.getTfHelveticaNueu(context);

		txtHeading = (TextView) findViewById(R.id.txt_heading_browse_youtube);
		txtHeading.setTypeface(UtilityClass.getTfHelveticaNueuLtPro(context));

		txtTitle = (TextView) findViewById(R.id.txt_title_browse_youtube);
		txtTitle.setTypeface(HelveticaNueu);

		etSearch = (EditText) findViewById(R.id.et_search);
		etSearch.setTypeface(HelveticaNueu);

		btnSearch = (Button) findViewById(R.id.btn_search);
		btnSearch.setOnClickListener(new YouTubeSearchBtnListner(this, context,
				etSearch));

		listYoutubeCategory = (ListView) findViewById(R.id.list_youtube_categories);


		loadCategoryListDataFromResources();

	}

	@SuppressLint("ParserError")
	private void loadCategoryListDataFromResources() {
		youtubeBrowseList = new ArrayList<YoutubeBrowseModel>();

		String[] youTubeCategories = getResources().getStringArray(
				R.array.youtube_categories);
		String[] youTubeCategoriesKeyWord = getResources().getStringArray(
				R.array.youtube_categories_keyword);

		for (int i = 0; i < youTubeCategories.length; i++) {
			YoutubeBrowseModel youtubeBrowseModel = new YoutubeBrowseModel();
			youtubeBrowseModel.setCategoryName(youTubeCategories[i]);
			youtubeBrowseModel.setCategoryKey(youTubeCategoriesKeyWord[i]);
			youtubeBrowseList.add(youtubeBrowseModel);

		}
		youTubeBrowseAdapter = new YouTubeBrowseAdapter(context,
				youtubeBrowseList);
		listYoutubeCategory.setAdapter(youTubeBrowseAdapter);
		youTubeBrowseAdapter.notifyDataSetChanged();

		listYoutubeCategory
				.setOnItemClickListener(new YouTubeCategoryItemClickListener(
						context, youtubeBrowseList));

	}

	@Override
	protected void onPause() {
		super.onPause();
		overridePendingTransition(0, 0);
	}

	@Override
	public void onBackPressed() {
		super.onBackPressed();
		finish();
	}

	@Override
	protected void onDestroy() {
		super.onDestroy();
	}

	@Override
	public void aleartDialogDelegateClick(int code) {
		
		
	}
}
