package com.mobisoft.youtubedatareading.adapters;

import java.util.ArrayList;

import android.content.Context;
import android.graphics.Typeface;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.mobisoft.youtubedatareading.R;
import com.mobisoft.youtubedatareading.models.YoutubeBrowseModel;
import com.mobisoft.youtubedatareading.utils.UtilityClass;

public class YouTubeBrowseAdapter extends BaseAdapter {

	private Context context;
	private ViewHolder holder;
	private ArrayList<YoutubeBrowseModel> youtubeBrowseList;
	private LayoutInflater mInflater;

	public YouTubeBrowseAdapter(Context context,
			ArrayList<YoutubeBrowseModel> youtubeBrowseList) {
		this.context = context;
		this.youtubeBrowseList = youtubeBrowseList;
		mInflater = LayoutInflater.from(context);
	}

	@Override
	public int getCount() {

		return youtubeBrowseList.size();
	}

	@Override
	public Object getItem(int position) {
		return youtubeBrowseList.get(position);
	}

	@Override
	public long getItemId(int position) {

		return position;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		holder = new ViewHolder();
		if (convertView == null) {
			convertView = mInflater
					.inflate(R.layout.browse_you_tube_item, null);
			holder.txtCategoryName = (TextView) convertView
					.findViewById(R.id.txt_category_name);
			convertView.setTag(holder);
		} else {
			holder = (ViewHolder) convertView.getTag();
		}
		Typeface tf = UtilityClass.getTfHelveticaNueuLtPro(context);
		holder.txtCategoryName.setTypeface(tf);
		holder.txtCategoryName.setText(youtubeBrowseList.get(position)
				.getCategoryName());
		return convertView;
	}

	private class ViewHolder {

		TextView txtCategoryName;
	}
}