package com.mobisoft.youtubedatareading.interfaces;

import java.util.ArrayList;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.net.Uri;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;

import com.mobisoft.youtubedatareading.models.VideoListModel;
import com.mobisoft.youtubedatareading.utils.Logger;
import com.mobisoft.youtubedatareading.utils.UtilityClass;

public class VideoListItemClickListener extends Activity implements
		OnItemClickListener, KeyValuePairInterface {
	private Context context;
	private ArrayList<VideoListModel> videoArrayList;

	public VideoListItemClickListener(Context context,
			ArrayList<VideoListModel> videoArrayList) {
		this.context = context;
		this.videoArrayList = videoArrayList;
	}

	@Override
	public void onItemClick(AdapterView<?> parent, View view, int position,
			long id) {

		Logger.debug("" + videoArrayList.size());

		String url = videoArrayList.get(position).getUrl();

		if (!UtilityClass.getNetworkState(context)) {
			UtilityClass.showAlerDialog(context, ERROR, INTERNET_NOT_AVAILABLE,
					null, 0);
		} else {
			context.startActivity(new Intent(Intent.ACTION_VIEW, Uri.parse(url)));
		}
	}
}
