package com.mobisoft.youtubedatareading.listeners;

import java.util.ArrayList;

import android.content.Context;
import android.content.Intent;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;

import com.mobisoft.youtubedatareading.YouTubeVideoListActivity;
import com.mobisoft.youtubedatareading.interfaces.KeyValuePairInterface;
import com.mobisoft.youtubedatareading.models.YoutubeBrowseModel;

public class YouTubeCategoryItemClickListener implements OnItemClickListener,
		KeyValuePairInterface {

	private Context context;
	private ArrayList<YoutubeBrowseModel> youtubeBrowseList;
	private String url;
	private YoutubeBrowseModel youtubeBrowseModel;

	public YouTubeCategoryItemClickListener(Context context,
			ArrayList<YoutubeBrowseModel> youtubeBrowseList) {
		this.context = context;
		this.youtubeBrowseList = youtubeBrowseList;
		url = YOUTUBE_BROWSE_URL;
		youtubeBrowseModel = new YoutubeBrowseModel();
	}

	@Override
	public void onItemClick(AdapterView<?> parent, View view, int position,
			long id) {

		youtubeBrowseModel = youtubeBrowseList.get(position);
		String requestUrl;
		if (!youtubeBrowseModel.getCategoryName().equalsIgnoreCase("ALL")) {
			requestUrl = url + "/-/" + youtubeBrowseModel.getCategoryKey();
		} else {
			requestUrl = url;
		}

		Intent intent = new Intent(context, YouTubeVideoListActivity.class);
		intent.putExtra(URL, requestUrl);
		intent.putExtra(SEARCH_KEYWORD, "");
		context.startActivity(intent);

	}
}
