package com.mobisoft.youtubedatareading.listeners;

import android.content.Context;
import android.content.Intent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.EditText;

import com.mobisoft.youtubedatareading.YouTubeVideoListActivity;
import com.mobisoft.youtubedatareading.interfaces.AlertDialogDelegate;
import com.mobisoft.youtubedatareading.interfaces.KeyValuePairInterface;

public class YouTubeSearchBtnListner implements OnClickListener,
		KeyValuePairInterface {

	private Context context;
	private EditText etSearch;
	private AlertDialogDelegate delegate;
	private String url;

	public YouTubeSearchBtnListner(AlertDialogDelegate delegate,
			Context context, EditText etSearch) {
		this.context = context;
		this.etSearch = etSearch;
		this.delegate = delegate;
		url = YOUTUBE_BROWSE_URL;

	}

	@Override
	public void onClick(View v) {

		String searchText = etSearch.getText().toString().trim();

		if (searchText.equals("")) {
			delegate.aleartDialogDelegateClick(ET_SEARCH_BLANK);
		} else {

			searchText = searchText.replace(" ", "%20");

			String query = "&q=" + searchText;

			Intent intent = new Intent(context, YouTubeVideoListActivity.class);
			intent.putExtra(URL, url);
			intent.putExtra(SEARCH_KEYWORD, query);
			context.startActivity(intent);
		}

	}

}
