package com.mobisoft.youtubedatareading.network;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import org.apache.http.Header;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.methods.HttpDelete;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.client.methods.HttpPut;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.protocol.HTTP;
import org.apache.http.util.EntityUtils;

import com.mobisoft.youtubedatareading.utils.Logger;

public class APICall {

	public static int RECORD_COUNT = 0;

	public String jsonFromUrlGetRequest(AbstractModel requestModel) {

		String responseJson = "";
		// InputStream getResponseInputStream = null;

		HttpGet httpGet = new HttpGet(requestModel.getRequestUrl());
		if (requestModel.getHeaderKey() != null)
			httpGet.setHeader(requestModel.getHeaderKey(),
					requestModel.getHeaderValue());
		DefaultHttpClient httpClient = new DefaultHttpClient();

		HttpResponse httpResponse;

		try {

			httpResponse = httpClient.execute(httpGet);

			setRecordCountFromHeader(httpResponse);

			HttpEntity httpEntity = httpResponse.getEntity();
			responseJson = EntityUtils.toString(httpEntity);
			// getResponseInputStream = httpEntity.getContent();\

		} catch (ClientProtocolException e) {
			e.printStackTrace();
			Logger.debug("ClientProtocolException " + e.toString());

		} catch (IOException e) {
			e.printStackTrace();
			Logger.debug("IOException  " + e.toString());
		}

		/*
		 * if (getResponseInputStream != null) {
		 * 
		 * responseJson = getJsonStringFromInputstream(getResponseInputStream);
		 * Logger.debug("json getResponseInputStream : " + responseJson);
		 * 
		 * }
		 */

		return responseJson;
	}

	public String jsonFromUrlPutRequest(AbstractModel requestModel) {

		String responseJson = "";
		InputStream postResponseInputStream = null;

		StringEntity entity;

		HttpPut httpPut = new HttpPut(requestModel.getRequestUrl());
		DefaultHttpClient httpClient = new DefaultHttpClient();

		HttpResponse httpResponse;

		try {

			entity = new StringEntity(requestModel.getPostJsonString(),
					HTTP.UTF_8);
			entity.setContentType("application/json");
			httpPut.setEntity(entity);

			if (requestModel.getHeaderKey() != null)
				httpPut.setHeader(requestModel.getHeaderKey(),
						requestModel.getHeaderValue());

			httpResponse = httpClient.execute(httpPut);

			setRecordCountFromHeader(httpResponse);

			HttpEntity httpEntity = httpResponse.getEntity();
			postResponseInputStream = httpEntity.getContent();

		} catch (ClientProtocolException e) {
			e.printStackTrace();
			Logger.debug("ClientProtocolException " + e.toString());

		} catch (IOException e) {
			e.printStackTrace();
			Logger.debug("IOException  " + e.toString());
		}

		if (postResponseInputStream != null) {

			responseJson = getJsonStringFromInputstream(postResponseInputStream);
			// Logger.debug("json postResponseInputStream : " + responseJson);

		}

		return responseJson;

	}

	public String jsonFromUrlPostRequest(AbstractModel requestModel) {

		String responseJson = "";
		InputStream postResponseInputStream = null;

		StringEntity entity;

		HttpPost httpPost = new HttpPost(requestModel.getRequestUrl());
		DefaultHttpClient httpClient = new DefaultHttpClient();

		HttpResponse httpResponse;

		try {

			entity = new StringEntity(requestModel.getPostJsonString(),
					HTTP.UTF_8);
			entity.setContentType("application/json");
			httpPost.setEntity(entity);

			if (requestModel.getHeaderKey() != null)
				httpPost.setHeader(requestModel.getHeaderKey(),
						requestModel.getHeaderValue());

			httpResponse = httpClient.execute(httpPost);

			setRecordCountFromHeader(httpResponse);

			HttpEntity httpEntity = httpResponse.getEntity();
			postResponseInputStream = httpEntity.getContent();

		} catch (ClientProtocolException e) {
			e.printStackTrace();
			Logger.debug("ClientProtocolException " + e.toString());

		} catch (IOException e) {
			e.printStackTrace();
			Logger.debug("IOException  " + e.toString());
		}

		if (postResponseInputStream != null) {

			responseJson = getJsonStringFromInputstream(postResponseInputStream);
			// Logger.debug("json postResponseInputStream : " + responseJson);

		}

		return responseJson;

	}

	public String jsonFromUrlDeleteRequest(AbstractModel requestModel) {
		String responseJson = "";
		InputStream postResponseInputStream = null;

		HttpDelete httpDelete = new HttpDelete(requestModel.getRequestUrl());
		DefaultHttpClient httpClient = new DefaultHttpClient();

		HttpResponse httpResponse;

		try {
			if (requestModel.getHeaderKey() != null)
				httpDelete.setHeader(requestModel.getHeaderKey(),
						requestModel.getHeaderValue());

			httpResponse = httpClient.execute(httpDelete);

			setRecordCountFromHeader(httpResponse);

			HttpEntity httpEntity = httpResponse.getEntity();
			postResponseInputStream = httpEntity.getContent();

		} catch (ClientProtocolException e) {
			e.printStackTrace();
			Logger.debug("ClientProtocolException " + e.toString());

		} catch (IOException e) {
			e.printStackTrace();
			Logger.debug("IOException  " + e.toString());
		}

		if (postResponseInputStream != null) {

			responseJson = getJsonStringFromInputstream(postResponseInputStream);
			// Logger.debug("json postResponseInputStream : " + responseJson);

		}

		return responseJson;
	}

	private String getJsonStringFromInputstream(InputStream inputStream) {

		String json = "";

		try {

			BufferedReader reader = new BufferedReader(new InputStreamReader(
					inputStream, "iso-8859-1"), 8);
			StringBuilder sb = new StringBuilder();
			String line = null;

			while ((line = reader.readLine()) != null) {
				sb.append(line + "\n");
			}

			inputStream.close();
			json = sb.toString();

		} catch (Exception e) {

			Logger.debug("Buffer Error Error converting result " + e.toString());

		}

		return json;
	}

	private void setRecordCountFromHeader(HttpResponse httpResponse) {

		Header recordCountHeader = httpResponse.getLastHeader("records-count");

		if (recordCountHeader != null)
			RECORD_COUNT = Integer.parseInt(recordCountHeader.getValue());
		else
			RECORD_COUNT = 0;

		Logger.debug("Record Count :" + RECORD_COUNT);

	}

}
