package com.mobisoft.youtubedatareading.network;

import java.io.File;
import java.io.FileOutputStream;

import android.content.Context;
import android.graphics.Bitmap;
import android.os.AsyncTask;
import android.os.Environment;

import com.mobisoft.youtubedatareading.interfaces.ImageLoadAsyncTaskDelegate;
import com.mobisoft.youtubedatareading.interfaces.KeyValuePairInterface;
import com.mobisoft.youtubedatareading.utils.Logger;
import com.mobisoft.youtubedatareading.utils.UtilityClass;

public class ImageLoadAsynkTask extends AsyncTask<Void, Void, String> implements
		KeyValuePairInterface {
	private String url;
	private String fname;
	private Bitmap bitmap;
	private ImageLoadAsyncTaskDelegate delegate;
	private boolean mExternalStorageAvailable;
	private boolean mExternalStorageWriteable;
	private boolean imageFromSdFlag;

	public ImageLoadAsynkTask(ImageLoadAsyncTaskDelegate delegate, String url,
			Context context) {
		this.delegate = delegate;
		// this.context = context;
		this.url = url;
		mExternalStorageAvailable = false;
		mExternalStorageWriteable = false;
		imageFromSdFlag = false;

	}

	@Override
	protected void onPreExecute() {
		super.onPreExecute();

		Logger.debug("Image url:" + url);

		// http://img.youtube.com/vi/" + youtubeVideoId	+ "/hqdefault.jpg";
		if (url != null) {

			if (!url.equals("")) {

				if (url.contains("youtube.com")) {
					Logger.debug(url);
					fname = url.substring(("http://img.youtube.com/vi/")
							.length());
					fname = fname.replace("/", "-");
				} else if (url.contains("&")) {
					fname = url.substring(url.indexOf("imageName="),
							url.indexOf("&"));
				} else {
					String imageFileName = url.replace("/", "-");
					fname = imageFileName.substring(
							imageFileName.indexOf("images-"),
							imageFileName.length());
				}
			}
		}
		// http:--23.21.250.102:8080-qdayinspiration-assets-images-quote.png

		String state = Environment.getExternalStorageState();

		if (Environment.MEDIA_MOUNTED.equals(state)) {
			// We can read and write the media
			mExternalStorageAvailable = mExternalStorageWriteable = true;
		} else if (Environment.MEDIA_MOUNTED_READ_ONLY.equals(state)) {
			// We can only read the media
			mExternalStorageAvailable = true;
			mExternalStorageWriteable = false;
		} else {
			// Something else is wrong. It may be one of many other states, but
			// all we need
			// to know is we can neither read nor write
			mExternalStorageAvailable = mExternalStorageWriteable = false;
		}
	}

	@SuppressWarnings("finally")
	@Override
	protected String doInBackground(Void... params) {
		Logger.debug("image loading asynctask");
		String localPath = "";
		try {
			Logger.debug("Try image loading asynctask");
			if (mExternalStorageAvailable) {
				File imageFile = new File(APP_DATA_PATH + fname);
				if (imageFile.exists()) {
					imageFromSdFlag = true;
				} else {
					bitmap = UtilityClass.loadBitmap(url);
				}
			} else {
				Logger.debug("network download image loading asynctask");
				bitmap = UtilityClass.loadBitmap(url);
			}
			localPath = APP_DATA_PATH + fname;
		} catch (Exception e) {
			Logger.debug("Exception image loading asynctask");
			bitmap = null;
			e.printStackTrace();
			localPath = null;
		} finally {
			return localPath;
		}
	}

	@Override
	protected void onPostExecute(String localPath) {
		super.onPostExecute(localPath);
		if (bitmap != null) {
			if (mExternalStorageWriteable && !imageFromSdFlag)
				saveImage();
		}
		delegate.imageLoadCompletedWithResult(localPath);

	}

	

	void saveImage() {

		Logger.debug(fname);
		Logger.debug("IN save image");
		File filename;
		try {
			// Log.i("in save()", "after mkdir");
			UtilityClass.createAppDataFolderInSDCard();
			// new File(APP_DATA_PATH).mkdirs();
			filename = new File(APP_DATA_PATH + fname);
			// Log.i("in save()", "after file");
			FileOutputStream out = new FileOutputStream(filename);
			// Log.i("in save()", "after outputstream");
			bitmap.compress(Bitmap.CompressFormat.JPEG, 100, out);

			/*
			 * filename = new File(APP_DATA_PATH + ".nomedia"); out = new
			 * FileOutputStream(filename);
			 */

			out.flush();
			out.close();
			// Log.i("in save()", "after outputstream closed");
			/*
			 * MediaStore.Images.Media.insertImage(delegate.getContentResolver(),
			 * filename.getAbsolutePath(), filename.getName(),
			 * filename.getName());
			 */
			// bt.setText("Saved...");
			/*
			 * Toast.makeText(getApplicationContext(), "File is Saved in  " +
			 * filename, 1000).show();
			 */
		} catch (Exception e) {
			Logger.debug("Exception" + url);
			e.printStackTrace();
		}

	}
}
