package com.mobisoft.youtubedatareading.utils;

import java.util.ArrayList;

import android.content.Context;
import android.net.Uri;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.mobisoft.youtubedatareading.R;
import com.mobisoft.youtubedatareading.models.VideoListModel;

public class VideoListAdapter extends BaseAdapter {

	// private Context context;
	private ViewHolder holder;
	private ArrayList<VideoListModel> videoArrayList;
	private LayoutInflater mInflater;

	public VideoListAdapter(Context context,
			ArrayList<VideoListModel> videoArrayList) {
		// this.context = context;
		this.videoArrayList = videoArrayList;
		mInflater = LayoutInflater.from(context);
	}

	@Override
	public int getCount() {

		return videoArrayList.size();
	}

	@Override
	public Object getItem(int position) {
		return videoArrayList.get(position);
	}

	@Override
	public long getItemId(int position) {

		return position;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		holder = new ViewHolder();
		if (convertView == null) {
			convertView = mInflater.inflate(
					R.layout.videos_item, null);

			holder.imgThumbnail = (ImageView) convertView
					.findViewById(R.id.img_thumbnail);
			holder.title = (TextView) convertView.findViewById(R.id.txt_title);
			holder.date = (TextView) convertView.findViewById(R.id.txt_date);
			holder.views = (TextView) convertView.findViewById(R.id.txt_views);

			convertView.setTag(holder);
		} else {
			holder = (ViewHolder) convertView.getTag();
		}
		// Typeface tf = Typeface.createFromAsset(context.getAssets(),
		// "font/HelveticaNeueLTCom-LtCn.ttf");

		String localPath = videoArrayList.get(position).getImgLocalPath();

		if (localPath != null) {

			holder.imgThumbnail.setImageURI(Uri.parse(localPath));
		}
		holder.title.setText("" + videoArrayList.get(position).getTitle());
		holder.date.setText("" + videoArrayList.get(position).getDate());
		holder.views.setText("" + videoArrayList.get(position).getViews());
		Logger.debug("position :" + position);

		return convertView;
	}

	private class ViewHolder {

		ImageView imgThumbnail;
		TextView title;
		TextView date;
		TextView views;
	}
}